#include "vbe.h"
#include "icon.h"

struct vbe_interface display;

void put_pixel(uint32_t color, uint32_t x, uint32_t y)
{
	// divide by 4 because display.buff is in 32bit instead of 8bit
	const uint32_t coords = x + y * display.pitch / 4;
	display.buff[coords] = color;
}

void draw_icon(uint32_t pos_x, uint32_t pos_y, struct icon *img)
{
	for (uint32_t y = 0; y < img->height; y++) {
		for (uint32_t x = 0; x < img->width; x++) {
			put_pixel(img->pixels[y * img->width + x], pos_x + x,
			          pos_y + y);
		}
	}
}
