#include "debug.h"
#include "kprintf.h"
#include "memory.h"
void init_page_table(uint32_t page_table[1024], uint16_t start)
{
	for (uint16_t i = start; i < 1024; i++)
		page_table[i] = (i << 12) | 0x03;
}

int16_t add_page_table(uint16_t pd_index)
{
	void *frame = alloc_frame();
	if (!frame)
		return -1;
	page_table_default[PT_START + pd_index] =
	    ((uint32_t)frame & PAGE_MASK) | 0x03;
	uint32_t *page_table =
	    (uint32_t *)GET_PAGE_ADDR(0, PT_START + pd_index);
	init_page_table(page_table, 0);
	kernel_pd[pd_index] = ((uint32_t)frame & PAGE_MASK) | 0x03;
	return 0;
}
