#include "interrupts.h"
#include "kprintf.h"
#include "task.h"

uint16_t fork(void)
{
	current_task->status = FORKED;
	scheduler();
	return current_task->child ? current_task->child->pid : 0;
}

void kfork(struct task *daddy)
{
	cli();
	struct task *child = copy_task(daddy);
	if (!child) {
		kprintf(KERN_ALERT "Fork failed ! retry at the next loop");
		toris();
		return;
	}
	child->daddy = daddy;
	daddy->child = child;
	daddy->status = RUN;
	child->status = RUN;
	toris();
}
