#include "alloc.h"
#include "debug.h"
#include "interrupts.h"
#include "kprintf.h"
#include "task.h"
#include "time.h"

#include <stddef.h>

struct task *current_task;

void scheduler(void)
{
	//	ZOMBIE, THREAD, RUN, WAIT, SLEEP, STOPPED, FORKED
	void (*func[])(struct task *) = {
	    zombify_task, NULL, NULL, NULL, NULL, remove_task, kfork,
	};

	if (!current_task) // || current_task->next == current_task)
		return;
	cli();
	switch_pd(kernel_pd, (uint32_t *)((uint32_t)kernel_pd - HEAP_END));
	struct task *it = current_task->next;
	while (it && it->status != RUN) {
		if (it != current_task && func[it->status]) {
			struct task *new_it = it->prev;
			func[it->status](it);
			it = new_it;
		}
		it = it->next;
	}
	switch_to_task(it);
	exec_signal_pending();
	toris();
}
