#include "kprintf.h"
#include "string.h"
#include "terminal.h"
#include "utils.h"
#include <stdint.h>

void color_cmd(char *arg)
{
	uint8_t tmp_color;
	static const char *colors[] = {
	    "BLACK",     "BLUE",          "GREEN",        "CYAN",
	    "RED",       "MAGENTA",       "BROWN",        "LIGHT_GREY",
	    "DARK_GREY", "LIGHT_BLUE",    "LIGHT_GREEN",  "LIGHT_CYAN",
	    "LIGHT_RED", "LIGHT_MAGENTA", "LIGHT_YELLOW", "WHITE",
	};

	if (!arg)
		goto invalid;
	for (size_t i = 0; i < ARRAY_SIZE(colors); i++) {
		if (strcmp(colors[i], arg) == 0) {
			terminal_change_default_fg_color(i);
			return;
		}
	}
invalid:
	tmp_color = terminal_get_default_color();
	kprintf(KERN_WARNING "Invalid argument\n");
	kprintf("Available colors: ");
	for (size_t i = 0; i < ARRAY_SIZE(colors); i++) {
		terminal_set_default_fg_color(i);
		kprintf(colors[i]);
		if (i != ARRAY_SIZE(colors) - 1)
			kprintf(", ");
	}
	terminal_set_default_fg_color(tmp_color);
	kprintf("\n");
}
